



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>k8s 集群中的etcd故障解决</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">k8s 集群中的etcd故障解决</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 01:44:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>一次在k8s集群中创建实例发现etcd集群状态出现连接失败状况，导致创建实例失败。于是排查了一下原因。</p>
<h3>问题来源</h3>
<p>下面是etcd集群健康状态：</p>
<div>
<pre class="prettyprint linenums">[root@docker01 ~]# cd /opt/kubernetes/ssl/<br />
[root@docker01 ssl]# /opt/kubernetes/bin/etcdctl \<br />
&gt; --ca-file=ca.pem --cert-file=server.pem --key-file=server-key.pem \<br />
&gt; --endpoints="https://10.0.0.99:2379,https://10.0.0.100:2379,https://10.0.0.111:2379" \<br />
&gt; cluster-health<br />
member 1bd4d12de986e887 is healthy: got healthy result from https://10.0.0.99:2379<br />
member 45396926a395958b is healthy: got healthy result from https://10.0.0.100:2379<br />
failed to check the health of member c2c5804bd87e2884 on https://10.0.0.111:2379: Get https://10.0.0.111:2379/health: net/http: TLS handshake timeout<br />
member c2c5804bd87e2884 is unreachable: [https://10.0.0.111:2379] are all unreachable<br />
cluster is healthy<br />
[root@docker01 ssl]# </pre>
</div>
<p>可以明显看到etcd节点03出现问题。</p>
<p>这个时候到节点03上来重启etcd服务如下：</p>
<div>
<pre class="prettyprint linenums">[root@docker03 ~]# systemctl restart etcd<br />
Job for etcd.service failed because the control process exited with error code. See "systemctl status etcd.service" and "journalctl -xe" for details.<br />
[root@docker03 ~]# journalctl -xe<br />
Mar 24 22:24:32 docker03 etcd[1895]: setting maximum number of CPUs to 1, total number of available CPUs is 1<br />
Mar 24 22:24:32 docker03 etcd[1895]: the server is already initialized as member before, starting as etcd member...<br />
Mar 24 22:24:32 docker03 etcd[1895]: peerTLS: cert = /opt/kubernetes/ssl/server.pem, key = /opt/kubernetes/ssl/server-key.pem, ca = , trusted-ca = /opt/kubernetes/ssl<br />
Mar 24 22:24:32 docker03 etcd[1895]: listening for peers on https://10.0.0.111:2380<br />
Mar 24 22:24:32 docker03 etcd[1895]: The scheme of client url http://127.0.0.1:2379 is HTTP while peer key/cert files are presented. Ignored key/cert files.<br />
Mar 24 22:24:32 docker03 etcd[1895]: listening for client requests on 127.0.0.1:2379<br />
Mar 24 22:24:32 docker03 etcd[1895]: listening for client requests on 10.0.0.111:2379<br />
Mar 24 22:24:32 docker03 etcd[1895]: member c2c5804bd87e2884 has already been bootstrapped<br />
Mar 24 22:24:32 docker03 systemd[1]: etcd.service: main process exited, code=exited, status=1/FAILURE<br />
Mar 24 22:24:32 docker03 systemd[1]: Failed to start Etcd Server.<br />
-- Subject: Unit etcd.service has failed<br />
-- Defined-By: systemd<br />
-- Support: http://lists.freedesktop.org/mailman/listinfo/systemd-devel<br />
--<br />
-- Unit etcd.service has failed.<br />
--<br />
-- The result is failed.<br />
Mar 24 22:24:32 docker03 systemd[1]: Unit etcd.service entered failed state.<br />
Mar 24 22:24:32 docker03 systemd[1]: etcd.service failed.<br />
Mar 24 22:24:33 docker03 systemd[1]: etcd.service holdoff time over, scheduling restart.<br />
Mar 24 22:24:33 docker03 systemd[1]: start request repeated too quickly for etcd.service<br />
Mar 24 22:24:33 docker03 systemd[1]: Failed to start Etcd Server.<br />
-- Subject: Unit etcd.service has failed<br />
-- Defined-By: systemd<br />
-- Support: http://lists.freedesktop.org/mailman/listinfo/systemd-devel<br />
--<br />
-- Unit etcd.service has failed.<br />
--<br />
-- The result is failed.<br />
Mar 24 22:24:33 docker03 systemd[1]: Unit etcd.service entered failed state.<br />
Mar 24 22:24:33 docker03 systemd[1]: etcd.service failed.</pre>
</div>
<p>并没有成功启动服务，可以看到提示信息：member c2c5804bd87e2884 has already been bootstrapped</p>
<p>查看资料说是：<br />One of the member was bootstrapped via discovery service. You must remove the previous data-dir to clean up the member information. Or the member will ignore the new configuration and start with the old configuration. That is why you see the mismatch.<br />大概意思：<br />其中一个成员是通过discovery service引导的。必须删除以前的数据目录来清理成员信息。否则成员将忽略新配置，使用旧配置。这就是为什么你看到了不匹配。<br />看到了这里，问题所在也就很明确了，启动失败的原因在于data-dir （/var/lib/etcd/default.etcd）中记录的信息与 etcd启动的选项所标识的信息不太匹配造成的。</p>
<h3>问题解决</h3>
<p>第一种方式我们可以通过修改启动参数解决这类错误。既然 data-dir 中已经记录信息，我们就没必要在启动项中加入多于配置。具体修改--initial-cluster-state参数：</p>
<div>
<pre class="prettyprint linenums">[root@docker03 ~]# cat /usr/lib/systemd/system/etcd.service<br />
[Unit]<br />
Description=Etcd Server<br />
After=network.target<br />
After=network-online.target<br />
Wants=network-online.target

[Service]<br />
Type=notify<br />
EnvironmentFile=-/opt/kubernetes/cfg/etcd<br />
ExecStart=/opt/kubernetes/bin/etcd \<br />
--name=${ETCD_NAME} \<br />
--data-dir=${ETCD_DATA_DIR} \<br />
--listen-peer-urls=${ETCD_LISTEN_PEER_URLS} \<br />
--listen-client-urls=${ETCD_LISTEN_CLIENT_URLS},http://127.0.0.1:2379 \<br />
--advertise-client-urls=${ETCD_ADVERTISE_CLIENT_URLS} \<br />
--initial-advertise-peer-urls=${ETCD_INITIAL_ADVERTISE_PEER_URLS} \<br />
--initial-cluster=${ETCD_INITIAL_CLUSTER} \<br />
--initial-cluster-token=${ETCD_INITIAL_CLUSTER} \<br />
--initial-cluster-state=existing \  # 将new这个参数修改成existing，启动正常！<br />
--cert-file=/opt/kubernetes/ssl/server.pem \<br />
--key-file=/opt/kubernetes/ssl/server-key.pem \<br />
--peer-cert-file=/opt/kubernetes/ssl/server.pem \<br />
--peer-key-file=/opt/kubernetes/ssl/server-key.pem \<br />
--trusted-ca-file=/opt/kubernetes/ssl/ca.pem \<br />
--peer-trusted-ca-file=/opt/kubernetes/ssl/ca.pem<br />
Restart=on-failure<br />
LimitNOFILE=65536

[Install]<br />
WantedBy=multi-user.target
</pre>
</div>
<p>我们将 --initial-cluster-state=new 修改成&nbsp;&nbsp;--initial-cluster-state=existing，再次重新启动就ok了。</p>
<p>第二种方式删除所有etcd节点的 data-dir 文件（不删也行），重启各个节点的etcd服务，这个时候，每个节点的data-dir的数据都会被更新，就不会有以上故障了。</p>
<p>第三种方式是复制其他节点的data-dir中的内容，以此为基础上以 --force-new-cluster 的形式强行拉起一个，然后以添加新成员的方式恢复这个集群。</p>
<p>这是目前的几种解决办法</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2ylx87.html">CSS 实现打字效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e4p4z9.html">html中&amp;lt&semi;radio&amp;gt&semi;单选按钮控件标签用法解析及如何设置默认选中</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvr7oj8.html">【Summary】ANSYS TRANSIENT ANALYSIS</a>
		</li>
						<li><a href="https://www.batexi.com/a/390y3dj8.html">手把手教你用新浪云容器 Java 搭建自己的网站</a>
		</li>
						<li><a href="https://www.batexi.com/a/495lzym8.html">scrollTo &comma; scrollBy区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1xr268.html">thinkphp框架验证码验证一次</a>
		</li>
						<li><a href="https://www.batexi.com/a/495kdw09.html">SunSonic 3&period;0 ORM开源框架的学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zm4l39.html">Linux运维</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m72eeq.html">Jmeter正则表达式提取器的使用方法（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok5l5l9.html">4560 NOIP2015 D2T2 子串</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv11ykyq.html">android CheckBox RadioButton 照片和文字的间距问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mellkoq.html">Servlet实现文件上传（深度）（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gev2kz8.html">java并发之TimeUnit理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpwn6j9.html">【数学建模】灰色系统理论II-Verhulst建模-GM&lpar;1&comma;N&rpar;-GM&lpar;2&comma;1&rpar;建模</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj30zx8.html">设 &dollar;y&lowbar;1&lpar;x&rpar;&comma; y&lowbar;2&lpar;x&rpar;&dollar; 是 &dollar;y&amp;&num;39&semi;&amp;&num;39&semi;&plus;p&lpar;x&rpar;y&amp;&num;39&semi;&plus;q&lpar;x&rpar;y&equals;0&dollar; 的两个解 &lpar;&dollar;p&lpar;x&rpar;&comma; q&lpar;x&rpar;&dollar; 连续&rpar;&comma; 且 &dollar;y&lowbar;1&lpar;x&lowbar;0&rpar;&equals;y&lowbar;2&lpar;x&lowbar;0&rpar;&equals;0&dollar;&comma; &dollar;y&lowbar;1&lpar;x&rpar;&bsol;not&bsol;equiv 0&dollar;&period; 试证&colon; &dollar;y&lowbar;1&lpar;x&rpar;&dollar;&comma; &dollar;y&lowbar;2&lpar;x&rpar;&dollar; 线性相关&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1kv3lq.html">两款不错的Linux密码生成工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g3m5mq.html">Python&mdash;&mdash;pyHook监听鼠标键盘事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll7r3kq.html">quartz 配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pjeyeq.html">JavaScript 记录页面停留时间-通过测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve0x619.html">tcp端口检测</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qyvdy6gq.html">Effective Java -- 对于所有对象都通用的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7emo2j9.html">前端学习 -- Css -- 文本样式</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kw25lq.html">scala 资料集结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2n5zj8.html">（32位）本体学习程序（ontoEnrich）系统使用说明文档</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kw33oq.html">雨林木风ghostwin7纯净版系统下载</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zk136v8.html">Jquery 较好的效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/93pxgd08.html">03 uni-app框架学习：轮播图组件的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zk1lxv8.html">学习mysql  replication gitd</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwldxdz9.html">Linux字符集的查看及修改【转】</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpmk6e9.html">2010 NEERC Western subregional</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
